/*
 * match_http.c
 *
 * filipe@rnl.ist.utl.pt
 */

#define __NO_VERSION__

#include <linux/config.h>

/*
#ifdef CONFIG_MODVERSIONS
#include <linux/modversions.h>
#endif
*/

#include <linux/smp.h>
#include <linux/module.h>
#include <linux/skbuff.h>
#include <linux/file.h>
#include <net/sock.h>

#define SIZE_MIN    30
#define SIZE_MAX    1000
#define HEADER_SIZE_MIN 15

static const unsigned char *methods_list[] = {
    "GET /get/",
    "GET /uri-res/",
    "GET /.hash=",
    "HTTP/1.1",
    NULL
};

static const unsigned char *headers_list[] = {
    "X-Kazaa-",
    "X-Gnutella-",
    NULL
};

static inline const unsigned char *
next_line(const unsigned char *data,
          const unsigned char *end)
{
    while(data <= end)
        if(*data++ == '\n') return data;

    return NULL;
}

static inline int
string_match(const unsigned char *data,
             const unsigned char **strings)
{
    int i = 0;
    while (strings[i]) {
        if(memcmp(data, strings[i], sizeof(strings[i]) - 1) == 0)
            return 1;
        i++;
    }
    return 0;
}


int
match_http( const unsigned char *data,
             const unsigned char *end)
{
    if (end - data < SIZE_MIN || end - data > SIZE_MAX) return 0;

    if( string_match(data, methods_list) == 0 )
        return 0;

    while ( (data = next_line(data, end)) ) {
        if(end - data < HEADER_SIZE_MIN)
            return 0;
        if( string_match(data, headers_list) )
            return 1; /* match */
    }

    return 0;
}
